%% Test slf with new data, (testData), 
%data that was not involved neither in the training nor in the checking


clear all, close all, clc

disp('Testing with an independent data set')
disp('----------------------------------------')

slfIni = readfis('slfIni');
slfCp = readfis('slfCp');
slfEnd = readfis('slfEnd');
slfChk = readfis('slfChk');

load('testData');
testData = testData';

testTargets = testData(:,end);
predIni = evalfis(slfIni, testData(:,1:2));
predCp = evalfis(slfCp, testData(:,1:2));
predEnd = evalfis(slfEnd, testData(:,1:2));
predChk = evalfis(slfChk, testData(:,1:2));
figure
subplot(411)
plot(testTargets,'ob')
hold on
plot(predIni,'.r')
legend('Target', 'Predicted initial FLS')
xlabel('Sample'), ylabel('Emissions')
title('Initial FLS')

subplot(412)
plot(testTargets,'ob')
hold on
plot(predCp,'.r')
legend('Target', 'Predicted @ Check point FLS')
xlabel('Sample'), ylabel('Emissions')
title('Check point FLS')

subplot(413)
plot(testTargets,'ob')
hold on
% plot(predEnd,'.m')
% legend('Target','Predicted trained FLS')
plot(predChk,'.r')
legend('Target', 'Predicted @ before overffiting')
xlabel('Sample'), ylabel('Emissions')
%title('Trained FLS')
title('Before overfitting FLS')

subplot(414)
plot(testTargets,'ob')
hold on
plot(predEnd,'.m')
legend('Target','Predicted trained FLS')
xlabel('Sample'), ylabel('Emissions')
title('Trained FLS')

format compact
disp('Initial FLS')
gofIniMSE = goodnessOfFit(testTargets, predIni, 'mse')
gofIniNMSE = goodnessOfFit(testTargets, predIni, 'nmse')
gofIniNRMSE = goodnessOfFit(testTargets, predIni, 'nrmse')

disp('  ')
disp('Intermediate training point FLS')
gofCpMSE = goodnessOfFit(testTargets, predCp, 'mse')
gofCpNMSE = goodnessOfFit(testTargets, predCp, 'nmse')
gofCpNRMSE = goodnessOfFit(testTargets, predCp, 'nrmse')

disp('  ')
disp('Final FLS')
gofEndMSE = goodnessOfFit(testTargets, predEnd, 'mse')
gofEndNMSE = goodnessOfFit(testTargets, predEnd, 'nmse')
gofEndNRMSE = goodnessOfFit(testTargets, predEnd, 'nrmse')

disp('  ')
disp('Checking FLS')
gofChkMSE = goodnessOfFit(testTargets, predChk, 'mse')
gofChkNMSE = goodnessOfFit(testTargets, predChk, 'nmse')
gofChkNRMSE = goodnessOfFit(testTargets, predChk, 'nrmse')